<template>
  <div class="information ma-4">
    <v-row class="ma-4">
      <h1 style="text-decoration: underline">Results</h1>
      <v-col v-for="index in CountSize()" cols="12">
        <v-card :color=ReportColor(index-1)>
          <v-card-title>
            <v-icon class="mr-4">{{ index }}</v-icon>
            {{ ReportTitle(index - 1) }}
          </v-card-title>
          <v-card-text>
            <b>Message: </b> {{ ReportMessage(index - 1) }}
          </v-card-text>
          <v-divider></v-divider>
          <v-card-text v-for="trace in ReportTrace(index-1).length">
            <div v-if="ReportTrace(index-1)[trace-1].file">
              <b>File: </b> {{ ReportTrace(index - 1)[trace - 1].file }}
            </div>
            <div v-if="ReportTrace(index-1)[trace-1].line">
              <b>Line: </b> {{ ReportTrace(index - 1)[trace - 1].line }}
            </div>
            <div v-if="ReportTrace(index-1)[trace-1].function">
              <b>Function: </b> {{ ReportTrace(index - 1)[trace - 1].function }}
            </div>
            <div v-if="ReportTrace(index-1)[trace-1].class">
              <b>Class: </b> {{ ReportTrace(index - 1)[trace - 1].class }}
            </div>
            <div v-if="ReportTrace(index-1)[trace-1].type">
              <b>Type: </b> {{ ReportTrace(index - 1)[trace - 1].type }}
            </div>
          </v-card-text>
          <v-divider></v-divider>
          <v-card-text><b>Time: </b> {{ ReportTime(index - 1) }}s</v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <h1 class="ma-4">Summary</h1>
    <v-row class="ma-4">
      <v-col>
        <p style="color: green">Successful:</p>
      </v-col>
      <v-col>{{ Count(0) }}</v-col>
      <v-col>
        <p style="color: red">Failed:</p>
      </v-col>
      <v-col>{{ Count(1) }}</v-col>
      <v-col>
        <p style="color: blue">Skipped:</p>
      </v-col>
      <v-col>{{ Count(2) }}</v-col>
      <v-col>
        <p style="color: gray">Incomplete:</p>
      </v-col>
      <v-col>{{ Count(3) }}</v-col>
    </v-row>
  </div>
</template>

<script>
let report = require('../../public/report.json');
let size = Object.keys(report).length;
export default {
  name: "Information",
  methods: {
    CountSize() {
      let count = 0;
      for (let i = 0; i < size; i++) {
        if (report[i].event === 'test') {
          count++;
        }
      }
      return count;
    },
    ReportTitle(index) {
      let titles = [];
      for (let i = 0; i < size; i++) {
        if (report[i].event === 'test') {
          titles.push(report[i].test[1]);
        }
      }
      return titles[index];
    },
    ReportTime(index) {
      let times = [];
      for (let i = 0; i < size; i++) {
        if (report[i].event === 'test') {
          times.push(report[i].time);
        }
      }
      return times[index];
    },
    ReportColor(index) {
      let colours = [];
      for (let i = 0; i < size; i++) {
        if (report[i].event === 'test') {
          if (report[i].suite === 'acceptance') {
            colours.push('red')
          }
          if (report[i].suite === 'successful') {
            colours.push('green')
          }
          if (report[i].suite === 'skipped') {
            colours.push('blue')
          }
          if (report[i].suite === 'incomplete') {
            colours.push('grey')
          }
        }
      }
      // console.log(colours);
      return colours[index];
    },
    ReportMessage(index) {
      let message = [];
      for (let i = 0; i < size; i++) {
        if (report[i].event === 'test') {
          message.push(report[i].message)
        }
      }
      return message[index];
    },
    ReportTrace(index) {
      let trace = [];
      for (let i = 0; i < size; i++) {
        if (report[i].event === 'test') {
          trace.push(report[i].trace)
        }
      }
      return trace[index];
    },
    Count(index) {
      let count = [];
      let f_count = 0, s_count = 0, sk_count = 0, in_count = 0;
      for (let i = 0; i < size; i++) {
        if (report[i].event === 'test') {
          if (report[i].suite === 'successful') {
            s_count++;
          }
          if (report[i].suite === 'acceptance') {
            f_count++;
          }
          if (report[i].suite === 'skipped') {
            sk_count++;
          }
          if (report[i].suite === 'incomplete') {
            in_count++;
          }

        }
      }
      count.push(s_count);
      count.push(f_count);
      count.push(sk_count);
      count.push(in_count);
      // console.log(count)
      return count[index];
    }
  }
}
</script>